// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type AssociateRouteTableRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* RouteTable ID  */
    RouteTableId string `json:"routeTableId"`

    /* 路由表要绑定的子网ID列表, subnet已被其他路由表绑定时，自动解绑。  */
    SubnetIds []string `json:"subnetIds"`
}

/*
 * param regionId: Region ID (Required)
 * param routeTableId: RouteTable ID (Required)
 * param subnetIds: 路由表要绑定的子网ID列表, subnet已被其他路由表绑定时，自动解绑。 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewAssociateRouteTableRequest(
    regionId string,
    routeTableId string,
    subnetIds []string,
) *AssociateRouteTableRequest {

	return &AssociateRouteTableRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/routeTables/{routeTableId}:associateRouteTable",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        RouteTableId: routeTableId,
        SubnetIds: subnetIds,
	}
}

/*
 * param regionId: Region ID (Required)
 * param routeTableId: RouteTable ID (Required)
 * param subnetIds: 路由表要绑定的子网ID列表, subnet已被其他路由表绑定时，自动解绑。 (Required)
 */
func NewAssociateRouteTableRequestWithAllParams(
    regionId string,
    routeTableId string,
    subnetIds []string,
) *AssociateRouteTableRequest {

    return &AssociateRouteTableRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/routeTables/{routeTableId}:associateRouteTable",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        RouteTableId: routeTableId,
        SubnetIds: subnetIds,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewAssociateRouteTableRequestWithoutParam() *AssociateRouteTableRequest {

    return &AssociateRouteTableRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/routeTables/{routeTableId}:associateRouteTable",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *AssociateRouteTableRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param routeTableId: RouteTable ID(Required) */
func (r *AssociateRouteTableRequest) SetRouteTableId(routeTableId string) {
    r.RouteTableId = routeTableId
}

/* param subnetIds: 路由表要绑定的子网ID列表, subnet已被其他路由表绑定时，自动解绑。(Required) */
func (r *AssociateRouteTableRequest) SetSubnetIds(subnetIds []string) {
    r.SubnetIds = subnetIds
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r AssociateRouteTableRequest) GetRegionId() string {
    return r.RegionId
}

type AssociateRouteTableResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result AssociateRouteTableResult `json:"result"`
}

type AssociateRouteTableResult struct {
}