// Code generated by protoc-gen-go. DO NOT EDIT.
// source: yandex/cloud/compute/v1/placement_group.proto

package compute

import (
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	timestamp "github.com/golang/protobuf/ptypes/timestamp"
	_ "github.com/yandex-cloud/go-genproto/yandex/cloud"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

type PlacementGroup struct {
	// ID of the placement group. Generated at creation time.
	Id string `protobuf:"bytes,1,opt,name=id,proto3" json:"id,omitempty"`
	// ID of the folder that the placement group belongs to.
	FolderId string `protobuf:"bytes,2,opt,name=folder_id,json=folderId,proto3" json:"folder_id,omitempty"`
	// Creation timestamp.
	CreatedAt *timestamp.Timestamp `protobuf:"bytes,3,opt,name=created_at,json=createdAt,proto3" json:"created_at,omitempty"`
	// Name of the placement group.
	// The name is unique within the folder.
	Name string `protobuf:"bytes,4,opt,name=name,proto3" json:"name,omitempty"`
	// Description of the placement group. 0-256 characters long.
	Description string `protobuf:"bytes,5,opt,name=description,proto3" json:"description,omitempty"`
	// Placement group labels as `key:value` pairs.
	Labels map[string]string `protobuf:"bytes,6,rep,name=labels,proto3" json:"labels,omitempty" protobuf_key:"bytes,1,opt,name=key,proto3" protobuf_val:"bytes,2,opt,name=value,proto3"`
	// Placement strategy. To specify a placement strategy, send the corresponding
	// field containing an empty structure.
	//
	// Types that are valid to be assigned to PlacementStrategy:
	//	*PlacementGroup_SpreadPlacementStrategy
	PlacementStrategy    isPlacementGroup_PlacementStrategy `protobuf_oneof:"placement_strategy"`
	XXX_NoUnkeyedLiteral struct{}                           `json:"-"`
	XXX_unrecognized     []byte                             `json:"-"`
	XXX_sizecache        int32                              `json:"-"`
}

func (m *PlacementGroup) Reset()         { *m = PlacementGroup{} }
func (m *PlacementGroup) String() string { return proto.CompactTextString(m) }
func (*PlacementGroup) ProtoMessage()    {}
func (*PlacementGroup) Descriptor() ([]byte, []int) {
	return fileDescriptor_0e9521ba5da0945a, []int{0}
}

func (m *PlacementGroup) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_PlacementGroup.Unmarshal(m, b)
}
func (m *PlacementGroup) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_PlacementGroup.Marshal(b, m, deterministic)
}
func (m *PlacementGroup) XXX_Merge(src proto.Message) {
	xxx_messageInfo_PlacementGroup.Merge(m, src)
}
func (m *PlacementGroup) XXX_Size() int {
	return xxx_messageInfo_PlacementGroup.Size(m)
}
func (m *PlacementGroup) XXX_DiscardUnknown() {
	xxx_messageInfo_PlacementGroup.DiscardUnknown(m)
}

var xxx_messageInfo_PlacementGroup proto.InternalMessageInfo

func (m *PlacementGroup) GetId() string {
	if m != nil {
		return m.Id
	}
	return ""
}

func (m *PlacementGroup) GetFolderId() string {
	if m != nil {
		return m.FolderId
	}
	return ""
}

func (m *PlacementGroup) GetCreatedAt() *timestamp.Timestamp {
	if m != nil {
		return m.CreatedAt
	}
	return nil
}

func (m *PlacementGroup) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *PlacementGroup) GetDescription() string {
	if m != nil {
		return m.Description
	}
	return ""
}

func (m *PlacementGroup) GetLabels() map[string]string {
	if m != nil {
		return m.Labels
	}
	return nil
}

type isPlacementGroup_PlacementStrategy interface {
	isPlacementGroup_PlacementStrategy()
}

type PlacementGroup_SpreadPlacementStrategy struct {
	SpreadPlacementStrategy *SpreadPlacementStrategy `protobuf:"bytes,7,opt,name=spread_placement_strategy,json=spreadPlacementStrategy,proto3,oneof"`
}

func (*PlacementGroup_SpreadPlacementStrategy) isPlacementGroup_PlacementStrategy() {}

func (m *PlacementGroup) GetPlacementStrategy() isPlacementGroup_PlacementStrategy {
	if m != nil {
		return m.PlacementStrategy
	}
	return nil
}

func (m *PlacementGroup) GetSpreadPlacementStrategy() *SpreadPlacementStrategy {
	if x, ok := m.GetPlacementStrategy().(*PlacementGroup_SpreadPlacementStrategy); ok {
		return x.SpreadPlacementStrategy
	}
	return nil
}

// XXX_OneofWrappers is for the internal use of the proto package.
func (*PlacementGroup) XXX_OneofWrappers() []interface{} {
	return []interface{}{
		(*PlacementGroup_SpreadPlacementStrategy)(nil),
	}
}

// This is an empty structure that must be passed to explicitly
// specify the required placement strategy.
type SpreadPlacementStrategy struct {
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *SpreadPlacementStrategy) Reset()         { *m = SpreadPlacementStrategy{} }
func (m *SpreadPlacementStrategy) String() string { return proto.CompactTextString(m) }
func (*SpreadPlacementStrategy) ProtoMessage()    {}
func (*SpreadPlacementStrategy) Descriptor() ([]byte, []int) {
	return fileDescriptor_0e9521ba5da0945a, []int{1}
}

func (m *SpreadPlacementStrategy) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_SpreadPlacementStrategy.Unmarshal(m, b)
}
func (m *SpreadPlacementStrategy) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_SpreadPlacementStrategy.Marshal(b, m, deterministic)
}
func (m *SpreadPlacementStrategy) XXX_Merge(src proto.Message) {
	xxx_messageInfo_SpreadPlacementStrategy.Merge(m, src)
}
func (m *SpreadPlacementStrategy) XXX_Size() int {
	return xxx_messageInfo_SpreadPlacementStrategy.Size(m)
}
func (m *SpreadPlacementStrategy) XXX_DiscardUnknown() {
	xxx_messageInfo_SpreadPlacementStrategy.DiscardUnknown(m)
}

var xxx_messageInfo_SpreadPlacementStrategy proto.InternalMessageInfo

func init() {
	proto.RegisterType((*PlacementGroup)(nil), "yandex.cloud.compute.v1.PlacementGroup")
	proto.RegisterMapType((map[string]string)(nil), "yandex.cloud.compute.v1.PlacementGroup.LabelsEntry")
	proto.RegisterType((*SpreadPlacementStrategy)(nil), "yandex.cloud.compute.v1.SpreadPlacementStrategy")
}

func init() {
	proto.RegisterFile("yandex/cloud/compute/v1/placement_group.proto", fileDescriptor_0e9521ba5da0945a)
}

var fileDescriptor_0e9521ba5da0945a = []byte{
	// 402 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x74, 0x92, 0xc1, 0x8e, 0xd3, 0x30,
	0x10, 0x86, 0x49, 0xdb, 0x2d, 0x74, 0x2a, 0xad, 0x90, 0x85, 0xd4, 0x6c, 0x56, 0x88, 0x6a, 0x4f,
	0xbd, 0xd4, 0xa6, 0xbb, 0x17, 0x16, 0x4e, 0x2c, 0x42, 0x80, 0xe0, 0x80, 0xb2, 0x9c, 0xb8, 0x44,
	0x4e, 0x3c, 0x1b, 0x2c, 0x9c, 0x38, 0x72, 0x9c, 0x88, 0xbc, 0x1d, 0xf0, 0x64, 0x28, 0x8e, 0x0b,
	0xad, 0xd8, 0xdc, 0x26, 0x33, 0xff, 0xcc, 0x7c, 0xf3, 0xc7, 0xb0, 0xed, 0x78, 0x29, 0xf0, 0x07,
	0xcb, 0x94, 0x6e, 0x04, 0xcb, 0x74, 0x51, 0x35, 0x16, 0x59, 0xbb, 0x63, 0x95, 0xe2, 0x19, 0x16,
	0x58, 0xda, 0x24, 0x37, 0xba, 0xa9, 0x68, 0x65, 0xb4, 0xd5, 0x64, 0x35, 0xc8, 0xa9, 0x93, 0x53,
	0x2f, 0xa7, 0xed, 0x2e, 0x7a, 0x96, 0x6b, 0x9d, 0x2b, 0x64, 0x4e, 0x96, 0x36, 0x77, 0xcc, 0xca,
	0x02, 0x6b, 0xcb, 0x0b, 0xdf, 0x19, 0x3d, 0x3d, 0x5a, 0xd4, 0x72, 0x25, 0x05, 0xb7, 0x52, 0x97,
	0x43, 0xf9, 0xe2, 0xf7, 0x14, 0x4e, 0x3f, 0xef, 0x57, 0xbe, 0xeb, 0x37, 0x92, 0x53, 0x98, 0x48,
	0x11, 0x06, 0xeb, 0x60, 0xb3, 0x88, 0x27, 0x52, 0x90, 0x73, 0x58, 0xdc, 0x69, 0x25, 0xd0, 0x24,
	0x52, 0x84, 0x13, 0x97, 0x7e, 0x34, 0x24, 0x3e, 0x08, 0x72, 0x0d, 0x90, 0x19, 0xe4, 0x16, 0x45,
	0xc2, 0x6d, 0x38, 0x5d, 0x07, 0x9b, 0xe5, 0x65, 0x44, 0x07, 0x28, 0xba, 0x87, 0xa2, 0x5f, 0xf6,
	0x50, 0xf1, 0xc2, 0xab, 0x5f, 0x5b, 0x42, 0x60, 0x56, 0xf2, 0x02, 0xc3, 0x99, 0x1b, 0xe9, 0x62,
	0xb2, 0x86, 0xa5, 0xc0, 0x3a, 0x33, 0xb2, 0xea, 0x19, 0xc3, 0x13, 0x57, 0x3a, 0x4c, 0x91, 0x8f,
	0x30, 0x57, 0x3c, 0x45, 0x55, 0x87, 0xf3, 0xf5, 0x74, 0xb3, 0xbc, 0xbc, 0xa2, 0x23, 0xd6, 0xd0,
	0xe3, 0xb3, 0xe8, 0x27, 0xd7, 0xf5, 0xb6, 0xb4, 0xa6, 0x8b, 0xfd, 0x08, 0x52, 0xc2, 0x59, 0x5d,
	0x19, 0xe4, 0x22, 0xf9, 0x67, 0x7b, 0x6d, 0x0d, 0xb7, 0x98, 0x77, 0xe1, 0x43, 0x77, 0xcc, 0xf3,
	0xd1, 0xf9, 0xb7, 0xae, 0xf3, 0xef, 0x96, 0x5b, 0xdf, 0xf7, 0xfe, 0x41, 0xbc, 0xaa, 0xef, 0x2f,
	0x45, 0xd7, 0xb0, 0x3c, 0xc0, 0x20, 0x8f, 0x61, 0xfa, 0x1d, 0x3b, 0x6f, 0x75, 0x1f, 0x92, 0x27,
	0x70, 0xd2, 0x72, 0xd5, 0xa0, 0xf7, 0x79, 0xf8, 0x78, 0x39, 0x79, 0x11, 0xdc, 0x44, 0x40, 0xfe,
	0x67, 0x24, 0xb3, 0x9f, 0xbf, 0x76, 0xc1, 0xc5, 0x19, 0xac, 0x46, 0x60, 0x6e, 0x52, 0x38, 0x3f,
	0xe2, 0xe7, 0x95, 0x3c, 0xb8, 0xe1, 0xeb, 0x9b, 0x5c, 0xda, 0x6f, 0x4d, 0xda, 0xa7, 0xd8, 0xa0,
	0xdb, 0x0e, 0x0f, 0x25, 0xd7, 0xdb, 0x1c, 0x4b, 0xf7, 0x03, 0xd9, 0xc8, 0x53, 0x7d, 0xe5, 0xc3,
	0x74, 0xee, 0x64, 0x57, 0x7f, 0x02, 0x00, 0x00, 0xff, 0xff, 0xec, 0x0f, 0x34, 0xad, 0xd4, 0x02,
	0x00, 0x00,
}
