// Code generated by protoc-gen-go. DO NOT EDIT.
// source: yandex/cloud/iot/devices/v1/device.proto

package devices

import (
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	timestamp "github.com/golang/protobuf/ptypes/timestamp"
	_ "github.com/yandex-cloud/go-genproto/yandex/cloud"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

type Device_Status int32

const (
	Device_STATUS_UNSPECIFIED Device_Status = 0
	// Device is being created.
	Device_CREATING Device_Status = 1
	// Device is ready to use.
	Device_ACTIVE Device_Status = 2
	// Device is being deleted.
	Device_DELETING Device_Status = 3
)

var Device_Status_name = map[int32]string{
	0: "STATUS_UNSPECIFIED",
	1: "CREATING",
	2: "ACTIVE",
	3: "DELETING",
}

var Device_Status_value = map[string]int32{
	"STATUS_UNSPECIFIED": 0,
	"CREATING":           1,
	"ACTIVE":             2,
	"DELETING":           3,
}

func (x Device_Status) String() string {
	return proto.EnumName(Device_Status_name, int32(x))
}

func (Device_Status) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_dc5d5b38a6ba5ae6, []int{0, 0}
}

// A device. For more information, see [Device](/docs/iot-core/concepts/index#device).
type Device struct {
	// ID of the device.
	Id string `protobuf:"bytes,1,opt,name=id,proto3" json:"id,omitempty"`
	// ID of the registry that the device belongs to.
	RegistryId string `protobuf:"bytes,2,opt,name=registry_id,json=registryId,proto3" json:"registry_id,omitempty"`
	// Creation timestamp.
	CreatedAt *timestamp.Timestamp `protobuf:"bytes,3,opt,name=created_at,json=createdAt,proto3" json:"created_at,omitempty"`
	// Name of the device. The name is unique within the registry.
	Name string `protobuf:"bytes,4,opt,name=name,proto3" json:"name,omitempty"`
	// Description of the device. 0-256 characters long.
	Description string `protobuf:"bytes,5,opt,name=description,proto3" json:"description,omitempty"`
	// Alias of a device topic.
	//
	// Alias is an alternate name of a device topic assigned by the user. Map alias to canonical topic name prefix, e.g. `my/custom/alias` match to `$device/abcdef/events`.
	TopicAliases map[string]string `protobuf:"bytes,6,rep,name=topic_aliases,json=topicAliases,proto3" json:"topic_aliases,omitempty" protobuf_key:"bytes,1,opt,name=key,proto3" protobuf_val:"bytes,2,opt,name=value,proto3"`
	// Status of the device.
	Status               Device_Status `protobuf:"varint,7,opt,name=status,proto3,enum=yandex.cloud.iot.devices.v1.Device_Status" json:"status,omitempty"`
	XXX_NoUnkeyedLiteral struct{}      `json:"-"`
	XXX_unrecognized     []byte        `json:"-"`
	XXX_sizecache        int32         `json:"-"`
}

func (m *Device) Reset()         { *m = Device{} }
func (m *Device) String() string { return proto.CompactTextString(m) }
func (*Device) ProtoMessage()    {}
func (*Device) Descriptor() ([]byte, []int) {
	return fileDescriptor_dc5d5b38a6ba5ae6, []int{0}
}

func (m *Device) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Device.Unmarshal(m, b)
}
func (m *Device) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Device.Marshal(b, m, deterministic)
}
func (m *Device) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Device.Merge(m, src)
}
func (m *Device) XXX_Size() int {
	return xxx_messageInfo_Device.Size(m)
}
func (m *Device) XXX_DiscardUnknown() {
	xxx_messageInfo_Device.DiscardUnknown(m)
}

var xxx_messageInfo_Device proto.InternalMessageInfo

func (m *Device) GetId() string {
	if m != nil {
		return m.Id
	}
	return ""
}

func (m *Device) GetRegistryId() string {
	if m != nil {
		return m.RegistryId
	}
	return ""
}

func (m *Device) GetCreatedAt() *timestamp.Timestamp {
	if m != nil {
		return m.CreatedAt
	}
	return nil
}

func (m *Device) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *Device) GetDescription() string {
	if m != nil {
		return m.Description
	}
	return ""
}

func (m *Device) GetTopicAliases() map[string]string {
	if m != nil {
		return m.TopicAliases
	}
	return nil
}

func (m *Device) GetStatus() Device_Status {
	if m != nil {
		return m.Status
	}
	return Device_STATUS_UNSPECIFIED
}

// A device certificate. For more information, see [Managing device certificates](/docs/iot-core/operations/certificates/device-certificates).
type DeviceCertificate struct {
	// ID of the device that the certificate belongs to.
	DeviceId string `protobuf:"bytes,1,opt,name=device_id,json=deviceId,proto3" json:"device_id,omitempty"`
	// SHA256 hash of the certificate.
	Fingerprint string `protobuf:"bytes,2,opt,name=fingerprint,proto3" json:"fingerprint,omitempty"`
	// Public part of the certificate.
	CertificateData string `protobuf:"bytes,3,opt,name=certificate_data,json=certificateData,proto3" json:"certificate_data,omitempty"`
	// Creation timestamp.
	CreatedAt            *timestamp.Timestamp `protobuf:"bytes,4,opt,name=created_at,json=createdAt,proto3" json:"created_at,omitempty"`
	XXX_NoUnkeyedLiteral struct{}             `json:"-"`
	XXX_unrecognized     []byte               `json:"-"`
	XXX_sizecache        int32                `json:"-"`
}

func (m *DeviceCertificate) Reset()         { *m = DeviceCertificate{} }
func (m *DeviceCertificate) String() string { return proto.CompactTextString(m) }
func (*DeviceCertificate) ProtoMessage()    {}
func (*DeviceCertificate) Descriptor() ([]byte, []int) {
	return fileDescriptor_dc5d5b38a6ba5ae6, []int{1}
}

func (m *DeviceCertificate) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_DeviceCertificate.Unmarshal(m, b)
}
func (m *DeviceCertificate) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_DeviceCertificate.Marshal(b, m, deterministic)
}
func (m *DeviceCertificate) XXX_Merge(src proto.Message) {
	xxx_messageInfo_DeviceCertificate.Merge(m, src)
}
func (m *DeviceCertificate) XXX_Size() int {
	return xxx_messageInfo_DeviceCertificate.Size(m)
}
func (m *DeviceCertificate) XXX_DiscardUnknown() {
	xxx_messageInfo_DeviceCertificate.DiscardUnknown(m)
}

var xxx_messageInfo_DeviceCertificate proto.InternalMessageInfo

func (m *DeviceCertificate) GetDeviceId() string {
	if m != nil {
		return m.DeviceId
	}
	return ""
}

func (m *DeviceCertificate) GetFingerprint() string {
	if m != nil {
		return m.Fingerprint
	}
	return ""
}

func (m *DeviceCertificate) GetCertificateData() string {
	if m != nil {
		return m.CertificateData
	}
	return ""
}

func (m *DeviceCertificate) GetCreatedAt() *timestamp.Timestamp {
	if m != nil {
		return m.CreatedAt
	}
	return nil
}

// A device password.
type DevicePassword struct {
	// ID of the device that the password belongs to.
	DeviceId string `protobuf:"bytes,1,opt,name=device_id,json=deviceId,proto3" json:"device_id,omitempty"`
	// ID of the password.
	Id string `protobuf:"bytes,2,opt,name=id,proto3" json:"id,omitempty"`
	// Creation timestamp.
	CreatedAt            *timestamp.Timestamp `protobuf:"bytes,3,opt,name=created_at,json=createdAt,proto3" json:"created_at,omitempty"`
	XXX_NoUnkeyedLiteral struct{}             `json:"-"`
	XXX_unrecognized     []byte               `json:"-"`
	XXX_sizecache        int32                `json:"-"`
}

func (m *DevicePassword) Reset()         { *m = DevicePassword{} }
func (m *DevicePassword) String() string { return proto.CompactTextString(m) }
func (*DevicePassword) ProtoMessage()    {}
func (*DevicePassword) Descriptor() ([]byte, []int) {
	return fileDescriptor_dc5d5b38a6ba5ae6, []int{2}
}

func (m *DevicePassword) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_DevicePassword.Unmarshal(m, b)
}
func (m *DevicePassword) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_DevicePassword.Marshal(b, m, deterministic)
}
func (m *DevicePassword) XXX_Merge(src proto.Message) {
	xxx_messageInfo_DevicePassword.Merge(m, src)
}
func (m *DevicePassword) XXX_Size() int {
	return xxx_messageInfo_DevicePassword.Size(m)
}
func (m *DevicePassword) XXX_DiscardUnknown() {
	xxx_messageInfo_DevicePassword.DiscardUnknown(m)
}

var xxx_messageInfo_DevicePassword proto.InternalMessageInfo

func (m *DevicePassword) GetDeviceId() string {
	if m != nil {
		return m.DeviceId
	}
	return ""
}

func (m *DevicePassword) GetId() string {
	if m != nil {
		return m.Id
	}
	return ""
}

func (m *DevicePassword) GetCreatedAt() *timestamp.Timestamp {
	if m != nil {
		return m.CreatedAt
	}
	return nil
}

func init() {
	proto.RegisterEnum("yandex.cloud.iot.devices.v1.Device_Status", Device_Status_name, Device_Status_value)
	proto.RegisterType((*Device)(nil), "yandex.cloud.iot.devices.v1.Device")
	proto.RegisterMapType((map[string]string)(nil), "yandex.cloud.iot.devices.v1.Device.TopicAliasesEntry")
	proto.RegisterType((*DeviceCertificate)(nil), "yandex.cloud.iot.devices.v1.DeviceCertificate")
	proto.RegisterType((*DevicePassword)(nil), "yandex.cloud.iot.devices.v1.DevicePassword")
}

func init() {
	proto.RegisterFile("yandex/cloud/iot/devices/v1/device.proto", fileDescriptor_dc5d5b38a6ba5ae6)
}

var fileDescriptor_dc5d5b38a6ba5ae6 = []byte{
	// 526 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x9c, 0x53, 0xdf, 0x6f, 0xd3, 0x30,
	0x10, 0x26, 0xe9, 0x16, 0xd6, 0xeb, 0x18, 0x9d, 0x85, 0x50, 0xd4, 0x09, 0xad, 0xea, 0x53, 0x41,
	0x9a, 0xa3, 0x15, 0x21, 0xf1, 0xe3, 0x01, 0x75, 0x6d, 0x18, 0x91, 0xd0, 0x34, 0xa5, 0x19, 0x0f,
	0x7b, 0x89, 0xdc, 0xd8, 0x0d, 0x86, 0x36, 0x8e, 0x92, 0x6b, 0x59, 0xff, 0x33, 0xfe, 0x11, 0xfe,
	0x1f, 0x54, 0x3b, 0x1d, 0xdd, 0x90, 0x2a, 0xe0, 0xed, 0xfc, 0xdd, 0x77, 0x9f, 0x3f, 0xdf, 0x9d,
	0xa1, 0xbb, 0x64, 0x19, 0x17, 0x37, 0x5e, 0x32, 0x55, 0x73, 0xee, 0x49, 0x85, 0x1e, 0x17, 0x0b,
	0x99, 0x88, 0xd2, 0x5b, 0x9c, 0x56, 0x21, 0xcd, 0x0b, 0x85, 0x8a, 0x1c, 0x19, 0x26, 0xd5, 0x4c,
	0x2a, 0x15, 0xd2, 0x8a, 0x49, 0x17, 0xa7, 0xad, 0xe3, 0x54, 0xa9, 0x74, 0x2a, 0x3c, 0x4d, 0x1d,
	0xcf, 0x27, 0x1e, 0xca, 0x99, 0x28, 0x91, 0xcd, 0x72, 0x53, 0xdd, 0x7a, 0x76, 0xe7, 0x9e, 0x05,
	0x9b, 0x4a, 0xce, 0x50, 0xaa, 0xcc, 0xa4, 0x3b, 0x3f, 0x6b, 0xe0, 0x0c, 0xb5, 0x1c, 0x39, 0x00,
	0x5b, 0x72, 0xd7, 0x6a, 0x5b, 0xdd, 0x7a, 0x68, 0x4b, 0x4e, 0x8e, 0xa1, 0x51, 0x88, 0x54, 0x96,
	0x58, 0x2c, 0x63, 0xc9, 0x5d, 0x5b, 0x27, 0x60, 0x0d, 0x05, 0x9c, 0xbc, 0x01, 0x48, 0x0a, 0xc1,
	0x50, 0xf0, 0x98, 0xa1, 0x5b, 0x6b, 0x5b, 0xdd, 0x46, 0xaf, 0x45, 0x8d, 0x21, 0xba, 0x36, 0x44,
	0xa3, 0xb5, 0xa1, 0xb0, 0x5e, 0xb1, 0xfb, 0x48, 0x08, 0xec, 0x64, 0x6c, 0x26, 0xdc, 0x1d, 0x2d,
	0xaa, 0x63, 0xd2, 0x86, 0x06, 0x17, 0x65, 0x52, 0xc8, 0x7c, 0xe5, 0xcf, 0xdd, 0xd5, 0xa9, 0x4d,
	0x88, 0x5c, 0xc3, 0x23, 0x54, 0xb9, 0x4c, 0x62, 0x36, 0x95, 0xac, 0x14, 0xa5, 0xeb, 0xb4, 0x6b,
	0xdd, 0x46, 0xef, 0x15, 0xdd, 0xd2, 0x21, 0x6a, 0x5e, 0x47, 0xa3, 0x55, 0x61, 0xdf, 0xd4, 0xf9,
	0x19, 0x16, 0xcb, 0x70, 0x1f, 0x37, 0x20, 0x72, 0x06, 0x4e, 0x89, 0x0c, 0xe7, 0xa5, 0xfb, 0xb0,
	0x6d, 0x75, 0x0f, 0x7a, 0x2f, 0xfe, 0x46, 0x74, 0xa4, 0x2b, 0xc2, 0xaa, 0xb2, 0xf5, 0x1e, 0x0e,
	0xff, 0xb8, 0x86, 0x34, 0xa1, 0xf6, 0x4d, 0x2c, 0xab, 0xbe, 0xae, 0x42, 0xf2, 0x04, 0x76, 0x17,
	0x6c, 0x3a, 0x17, 0x55, 0x4b, 0xcd, 0xe1, 0xad, 0xfd, 0xda, 0xea, 0x7c, 0x04, 0xc7, 0x48, 0x92,
	0xa7, 0x40, 0x46, 0x51, 0x3f, 0xba, 0x1a, 0xc5, 0x57, 0x17, 0xa3, 0x4b, 0x7f, 0x10, 0x7c, 0x08,
	0xfc, 0x61, 0xf3, 0x01, 0xd9, 0x87, 0xbd, 0x41, 0xe8, 0xf7, 0xa3, 0xe0, 0xe2, 0xbc, 0x69, 0x11,
	0x00, 0xa7, 0x3f, 0x88, 0x82, 0xcf, 0x7e, 0xd3, 0x5e, 0x65, 0x86, 0xfe, 0x27, 0x5f, 0x67, 0x6a,
	0x9d, 0x1f, 0x16, 0x1c, 0x1a, 0x93, 0x03, 0x51, 0xa0, 0x9c, 0xc8, 0x84, 0xa1, 0x20, 0x47, 0x50,
	0x37, 0x8f, 0x88, 0x6f, 0x27, 0xbd, 0x67, 0x80, 0x80, 0xaf, 0xfa, 0x3f, 0x91, 0x59, 0x2a, 0x8a,
	0xbc, 0x90, 0x19, 0x56, 0xe6, 0x36, 0x21, 0xf2, 0x1c, 0x9a, 0xc9, 0x6f, 0xb5, 0x98, 0x33, 0x64,
	0x7a, 0xec, 0xf5, 0xf0, 0xf1, 0x06, 0x3e, 0x64, 0xc8, 0xee, 0xed, 0xc6, 0xce, 0x3f, 0xec, 0x46,
	0xe7, 0x06, 0x0e, 0x8c, 0xf3, 0x4b, 0x56, 0x96, 0xdf, 0x55, 0xc1, 0xb7, 0xdb, 0x36, 0x6b, 0x6b,
	0xdf, 0xae, 0xed, 0xff, 0x6f, 0xe5, 0xd9, 0x57, 0x38, 0xbe, 0x33, 0x74, 0x96, 0xcb, 0x7b, 0x83,
	0xbf, 0x3e, 0x4f, 0x25, 0x7e, 0x99, 0x8f, 0x69, 0xa2, 0x66, 0x9e, 0xe1, 0x9e, 0x98, 0x9f, 0x95,
	0xaa, 0x93, 0x54, 0x64, 0x5a, 0xdf, 0xdb, 0xf2, 0xb5, 0xdf, 0x55, 0xe1, 0xd8, 0xd1, 0xd4, 0x97,
	0xbf, 0x02, 0x00, 0x00, 0xff, 0xff, 0xf2, 0x87, 0xa5, 0x1b, 0x08, 0x04, 0x00, 0x00,
}
