// Code generated by protoc-gen-go. DO NOT EDIT.
// source: yandex/cloud/mdb/clickhouse/v1/backup.proto

package clickhouse

import (
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	timestamp "github.com/golang/protobuf/ptypes/timestamp"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

// A ClickHouse Backup resource. See the [Developer's Guide](/docs/managed-clickhouse/concepts)
// for more information.
type Backup struct {
	// ID of the backup.
	Id string `protobuf:"bytes,1,opt,name=id,proto3" json:"id,omitempty"`
	// ID of the folder that the backup belongs to.
	FolderId string `protobuf:"bytes,2,opt,name=folder_id,json=folderId,proto3" json:"folder_id,omitempty"`
	// Creation timestamp in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format
	// (i.e. when the backup operation was completed).
	CreatedAt *timestamp.Timestamp `protobuf:"bytes,3,opt,name=created_at,json=createdAt,proto3" json:"created_at,omitempty"`
	// ID of the ClickHouse cluster that the backup was created for.
	SourceClusterId string `protobuf:"bytes,4,opt,name=source_cluster_id,json=sourceClusterId,proto3" json:"source_cluster_id,omitempty"`
	// Names of the shards included in the backup.
	SourceShardNames []string `protobuf:"bytes,6,rep,name=source_shard_names,json=sourceShardNames,proto3" json:"source_shard_names,omitempty"`
	// Time when the backup operation was started.
	StartedAt            *timestamp.Timestamp `protobuf:"bytes,5,opt,name=started_at,json=startedAt,proto3" json:"started_at,omitempty"`
	XXX_NoUnkeyedLiteral struct{}             `json:"-"`
	XXX_unrecognized     []byte               `json:"-"`
	XXX_sizecache        int32                `json:"-"`
}

func (m *Backup) Reset()         { *m = Backup{} }
func (m *Backup) String() string { return proto.CompactTextString(m) }
func (*Backup) ProtoMessage()    {}
func (*Backup) Descriptor() ([]byte, []int) {
	return fileDescriptor_a022447e16843e8f, []int{0}
}

func (m *Backup) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Backup.Unmarshal(m, b)
}
func (m *Backup) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Backup.Marshal(b, m, deterministic)
}
func (m *Backup) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Backup.Merge(m, src)
}
func (m *Backup) XXX_Size() int {
	return xxx_messageInfo_Backup.Size(m)
}
func (m *Backup) XXX_DiscardUnknown() {
	xxx_messageInfo_Backup.DiscardUnknown(m)
}

var xxx_messageInfo_Backup proto.InternalMessageInfo

func (m *Backup) GetId() string {
	if m != nil {
		return m.Id
	}
	return ""
}

func (m *Backup) GetFolderId() string {
	if m != nil {
		return m.FolderId
	}
	return ""
}

func (m *Backup) GetCreatedAt() *timestamp.Timestamp {
	if m != nil {
		return m.CreatedAt
	}
	return nil
}

func (m *Backup) GetSourceClusterId() string {
	if m != nil {
		return m.SourceClusterId
	}
	return ""
}

func (m *Backup) GetSourceShardNames() []string {
	if m != nil {
		return m.SourceShardNames
	}
	return nil
}

func (m *Backup) GetStartedAt() *timestamp.Timestamp {
	if m != nil {
		return m.StartedAt
	}
	return nil
}

func init() {
	proto.RegisterType((*Backup)(nil), "yandex.cloud.mdb.clickhouse.v1.Backup")
}

func init() {
	proto.RegisterFile("yandex/cloud/mdb/clickhouse/v1/backup.proto", fileDescriptor_a022447e16843e8f)
}

var fileDescriptor_a022447e16843e8f = []byte{
	// 305 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x84, 0x91, 0xcd, 0x4e, 0x02, 0x31,
	0x14, 0x85, 0xc3, 0xa0, 0xc4, 0xa9, 0x89, 0x3f, 0x5d, 0x4d, 0x30, 0x51, 0xc2, 0x8a, 0xa8, 0xb4,
	0x41, 0x57, 0xc6, 0x15, 0xb8, 0x62, 0xa1, 0x0b, 0x74, 0xe5, 0x66, 0xd2, 0xf6, 0x96, 0xa1, 0x61,
	0x4a, 0x49, 0x7f, 0x88, 0x3e, 0x80, 0xef, 0x6d, 0x68, 0x87, 0x10, 0x63, 0xa2, 0xcb, 0x9e, 0xfb,
	0xf5, 0x9c, 0x93, 0x7b, 0xd1, 0xcd, 0x27, 0x5b, 0x81, 0xfc, 0xa0, 0xa2, 0x36, 0x01, 0xa8, 0x06,
	0x4e, 0x45, 0xad, 0xc4, 0x72, 0x61, 0x82, 0x93, 0x74, 0x33, 0xa2, 0x9c, 0x89, 0x65, 0x58, 0x93,
	0xb5, 0x35, 0xde, 0xe0, 0xcb, 0x04, 0x93, 0x08, 0x13, 0x0d, 0x9c, 0xec, 0x61, 0xb2, 0x19, 0x75,
	0xaf, 0x2a, 0x63, 0xaa, 0x5a, 0xd2, 0x48, 0xf3, 0x30, 0xa7, 0x5e, 0x69, 0xe9, 0x3c, 0xd3, 0x8d,
	0x41, 0xff, 0x2b, 0x43, 0x9d, 0x49, 0x74, 0xc4, 0x27, 0x28, 0x53, 0x50, 0xb4, 0x7a, 0xad, 0x41,
	0x3e, 0xcb, 0x14, 0xe0, 0x0b, 0x94, 0xcf, 0x4d, 0x0d, 0xd2, 0x96, 0x0a, 0x8a, 0x2c, 0xca, 0x47,
	0x49, 0x98, 0x02, 0x7e, 0x40, 0x48, 0x58, 0xc9, 0xbc, 0x84, 0x92, 0xf9, 0xa2, 0xdd, 0x6b, 0x0d,
	0x8e, 0xef, 0xba, 0x24, 0xa5, 0x91, 0x5d, 0x1a, 0x79, 0xdb, 0xa5, 0xcd, 0xf2, 0x86, 0x1e, 0x7b,
	0x7c, 0x8d, 0xce, 0x9d, 0x09, 0x56, 0xc8, 0x52, 0xd4, 0xc1, 0xf9, 0xe4, 0x7f, 0x10, 0xfd, 0x4f,
	0xd3, 0xe0, 0x29, 0xe9, 0x53, 0xc0, 0xb7, 0x08, 0x37, 0xac, 0x5b, 0x30, 0x0b, 0xe5, 0x8a, 0x69,
	0xe9, 0x8a, 0x4e, 0xaf, 0x3d, 0xc8, 0x67, 0x67, 0x69, 0xf2, 0xba, 0x1d, 0xbc, 0x6c, 0xf5, 0x6d,
	0x29, 0xe7, 0x99, 0x6d, 0x4a, 0x1d, 0xfe, 0x5f, 0xaa, 0xa1, 0xc7, 0x7e, 0xe2, 0x50, 0xff, 0xc7,
	0x2a, 0xd9, 0x5a, 0xfd, 0x5e, 0xe7, 0xfb, 0x73, 0xa5, 0xfc, 0x22, 0x70, 0x22, 0x8c, 0xa6, 0x09,
	0x1f, 0xa6, 0x33, 0x55, 0x66, 0x58, 0xc9, 0x55, 0x8c, 0xa0, 0x7f, 0xdf, 0xef, 0x71, 0xff, 0xe2,
	0x9d, 0xf8, 0xe1, 0xfe, 0x3b, 0x00, 0x00, 0xff, 0xff, 0x55, 0x2e, 0x58, 0xa1, 0xf3, 0x01, 0x00,
	0x00,
}
