// Code generated by protoc-gen-go. DO NOT EDIT.
// source: yandex/cloud/mdb/mongodb/v1/user.proto

package mongodb

import (
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	_ "github.com/yandex-cloud/go-genproto/yandex/cloud"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

// A MongoDB User resource. For more information, see the
// [Developer's Guide](/docs/managed-mongodb/concepts).
type User struct {
	// Name of the MongoDB user.
	Name string `protobuf:"bytes,1,opt,name=name,proto3" json:"name,omitempty"`
	// ID of the MongoDB cluster the user belongs to.
	ClusterId string `protobuf:"bytes,2,opt,name=cluster_id,json=clusterId,proto3" json:"cluster_id,omitempty"`
	// Set of permissions granted to the user.
	Permissions          []*Permission `protobuf:"bytes,3,rep,name=permissions,proto3" json:"permissions,omitempty"`
	XXX_NoUnkeyedLiteral struct{}      `json:"-"`
	XXX_unrecognized     []byte        `json:"-"`
	XXX_sizecache        int32         `json:"-"`
}

func (m *User) Reset()         { *m = User{} }
func (m *User) String() string { return proto.CompactTextString(m) }
func (*User) ProtoMessage()    {}
func (*User) Descriptor() ([]byte, []int) {
	return fileDescriptor_4fde2355fb6bae94, []int{0}
}

func (m *User) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_User.Unmarshal(m, b)
}
func (m *User) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_User.Marshal(b, m, deterministic)
}
func (m *User) XXX_Merge(src proto.Message) {
	xxx_messageInfo_User.Merge(m, src)
}
func (m *User) XXX_Size() int {
	return xxx_messageInfo_User.Size(m)
}
func (m *User) XXX_DiscardUnknown() {
	xxx_messageInfo_User.DiscardUnknown(m)
}

var xxx_messageInfo_User proto.InternalMessageInfo

func (m *User) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *User) GetClusterId() string {
	if m != nil {
		return m.ClusterId
	}
	return ""
}

func (m *User) GetPermissions() []*Permission {
	if m != nil {
		return m.Permissions
	}
	return nil
}

type Permission struct {
	// Name of the database that the permission grants access to.
	DatabaseName string `protobuf:"bytes,1,opt,name=database_name,json=databaseName,proto3" json:"database_name,omitempty"`
	// MongoDB roles for the [database_name] database that the permission grants.
	Roles                []string `protobuf:"bytes,2,rep,name=roles,proto3" json:"roles,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *Permission) Reset()         { *m = Permission{} }
func (m *Permission) String() string { return proto.CompactTextString(m) }
func (*Permission) ProtoMessage()    {}
func (*Permission) Descriptor() ([]byte, []int) {
	return fileDescriptor_4fde2355fb6bae94, []int{1}
}

func (m *Permission) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Permission.Unmarshal(m, b)
}
func (m *Permission) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Permission.Marshal(b, m, deterministic)
}
func (m *Permission) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Permission.Merge(m, src)
}
func (m *Permission) XXX_Size() int {
	return xxx_messageInfo_Permission.Size(m)
}
func (m *Permission) XXX_DiscardUnknown() {
	xxx_messageInfo_Permission.DiscardUnknown(m)
}

var xxx_messageInfo_Permission proto.InternalMessageInfo

func (m *Permission) GetDatabaseName() string {
	if m != nil {
		return m.DatabaseName
	}
	return ""
}

func (m *Permission) GetRoles() []string {
	if m != nil {
		return m.Roles
	}
	return nil
}

type UserSpec struct {
	// Name of the MongoDB user.
	Name string `protobuf:"bytes,1,opt,name=name,proto3" json:"name,omitempty"`
	// Password of the MongoDB user.
	Password string `protobuf:"bytes,2,opt,name=password,proto3" json:"password,omitempty"`
	// Set of permissions to grant to the user.
	Permissions          []*Permission `protobuf:"bytes,3,rep,name=permissions,proto3" json:"permissions,omitempty"`
	XXX_NoUnkeyedLiteral struct{}      `json:"-"`
	XXX_unrecognized     []byte        `json:"-"`
	XXX_sizecache        int32         `json:"-"`
}

func (m *UserSpec) Reset()         { *m = UserSpec{} }
func (m *UserSpec) String() string { return proto.CompactTextString(m) }
func (*UserSpec) ProtoMessage()    {}
func (*UserSpec) Descriptor() ([]byte, []int) {
	return fileDescriptor_4fde2355fb6bae94, []int{2}
}

func (m *UserSpec) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_UserSpec.Unmarshal(m, b)
}
func (m *UserSpec) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_UserSpec.Marshal(b, m, deterministic)
}
func (m *UserSpec) XXX_Merge(src proto.Message) {
	xxx_messageInfo_UserSpec.Merge(m, src)
}
func (m *UserSpec) XXX_Size() int {
	return xxx_messageInfo_UserSpec.Size(m)
}
func (m *UserSpec) XXX_DiscardUnknown() {
	xxx_messageInfo_UserSpec.DiscardUnknown(m)
}

var xxx_messageInfo_UserSpec proto.InternalMessageInfo

func (m *UserSpec) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *UserSpec) GetPassword() string {
	if m != nil {
		return m.Password
	}
	return ""
}

func (m *UserSpec) GetPermissions() []*Permission {
	if m != nil {
		return m.Permissions
	}
	return nil
}

func init() {
	proto.RegisterType((*User)(nil), "yandex.cloud.mdb.mongodb.v1.User")
	proto.RegisterType((*Permission)(nil), "yandex.cloud.mdb.mongodb.v1.Permission")
	proto.RegisterType((*UserSpec)(nil), "yandex.cloud.mdb.mongodb.v1.UserSpec")
}

func init() {
	proto.RegisterFile("yandex/cloud/mdb/mongodb/v1/user.proto", fileDescriptor_4fde2355fb6bae94)
}

var fileDescriptor_4fde2355fb6bae94 = []byte{
	// 354 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xac, 0x92, 0xcd, 0x4a, 0xfb, 0x40,
	0x14, 0xc5, 0x49, 0x3f, 0xfe, 0xb4, 0xd3, 0x7f, 0x37, 0x83, 0x8b, 0xa0, 0x14, 0x4b, 0x05, 0xad,
	0x42, 0x66, 0x9c, 0x16, 0xa4, 0xa2, 0x2e, 0xec, 0xa6, 0x74, 0x23, 0x12, 0x71, 0x53, 0x91, 0x32,
	0xc9, 0x0c, 0x71, 0x24, 0xc9, 0x84, 0x99, 0xa4, 0x7e, 0xac, 0x5d, 0xf5, 0x75, 0x7c, 0x88, 0xf6,
	0x51, 0x5c, 0xfb, 0x04, 0xd2, 0x24, 0xd6, 0xd6, 0x45, 0x57, 0xee, 0x6e, 0xee, 0xf9, 0x9d, 0x70,
	0x0e, 0x77, 0xc0, 0xfe, 0x0b, 0x0d, 0x19, 0x7f, 0xc6, 0xae, 0x2f, 0x13, 0x86, 0x03, 0xe6, 0xe0,
	0x40, 0x86, 0x9e, 0x64, 0x0e, 0x9e, 0x10, 0x9c, 0x68, 0xae, 0x50, 0xa4, 0x64, 0x2c, 0xe1, 0x4e,
	0xc6, 0xa1, 0x94, 0x43, 0x01, 0x73, 0x50, 0xce, 0xa1, 0x09, 0xd9, 0x6e, 0xac, 0xfd, 0x64, 0x42,
	0x7d, 0xc1, 0x68, 0x2c, 0x64, 0x98, 0x79, 0x5b, 0x6f, 0x06, 0x28, 0xdd, 0x6a, 0xae, 0x20, 0x04,
	0xa5, 0x90, 0x06, 0xdc, 0x34, 0x9a, 0x46, 0xbb, 0x6a, 0xa7, 0x33, 0x6c, 0x00, 0xe0, 0xfa, 0x89,
	0x8e, 0xb9, 0x1a, 0x0b, 0x66, 0x16, 0x52, 0xa5, 0x9a, 0x6f, 0x86, 0x0c, 0x0e, 0x41, 0x2d, 0xe2,
	0x2a, 0x10, 0x5a, 0x0b, 0x19, 0x6a, 0xb3, 0xd8, 0x2c, 0xb6, 0x6b, 0x9d, 0x03, 0xb4, 0x21, 0x0d,
	0xba, 0x5e, 0xf2, 0xf6, 0xaa, 0xb7, 0x35, 0x00, 0xe0, 0x47, 0x82, 0x7b, 0xa0, 0xce, 0x68, 0x4c,
	0x1d, 0xaa, 0xf9, 0x78, 0x25, 0xd4, 0xff, 0xef, 0xe5, 0xd5, 0x22, 0xdc, 0x16, 0x28, 0x2b, 0xe9,
	0x73, 0x6d, 0x16, 0x9a, 0xc5, 0x76, 0xd5, 0xce, 0x3e, 0x5a, 0xef, 0x06, 0xa8, 0x2c, 0xfa, 0xdc,
	0x44, 0xdc, 0x85, 0x64, 0xb5, 0x53, 0xbf, 0xf1, 0x31, 0x23, 0xc6, 0xe7, 0x8c, 0xd4, 0xef, 0xa8,
	0xf5, 0x7a, 0x69, 0x8d, 0x8e, 0xad, 0xd3, 0xf1, 0xfd, 0xd1, 0x74, 0x4e, 0x4a, 0xe7, 0x17, 0x27,
	0xdd, 0xbc, 0xf2, 0x21, 0xa8, 0x44, 0x54, 0xeb, 0x27, 0xa9, 0xf2, 0xc2, 0xfd, 0xfa, 0xc2, 0x36,
	0x9d, 0x93, 0x72, 0xcf, 0x22, 0x9d, 0x9e, 0xbd, 0x94, 0xff, 0xb0, 0x7e, 0xff, 0x11, 0xec, 0xae,
	0xd9, 0x68, 0x24, 0x7e, 0x59, 0x47, 0x03, 0x4f, 0xc4, 0x0f, 0x89, 0x83, 0x5c, 0x19, 0xe0, 0x8c,
	0xb5, 0xb2, 0x93, 0x7a, 0xd2, 0xf2, 0x78, 0x98, 0x5e, 0x13, 0x6f, 0x78, 0x30, 0x67, 0xf9, 0xe8,
	0xfc, 0x4b, 0xd1, 0xee, 0x57, 0x00, 0x00, 0x00, 0xff, 0xff, 0x7d, 0x62, 0x62, 0xd0, 0x5e, 0x02,
	0x00, 0x00,
}
