// Code generated by protoc-gen-go. DO NOT EDIT.
// source: yandex/cloud/mdb/postgresql/v1/database.proto

package postgresql

import (
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	_ "github.com/yandex-cloud/go-genproto/yandex/cloud"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

// A PostgreSQL Database resource. For more information, see
// the [Developer's Guide](/docs/managed-postgresql/concepts).
type Database struct {
	// Name of the database.
	Name string `protobuf:"bytes,1,opt,name=name,proto3" json:"name,omitempty"`
	// ID of the PostgreSQL cluster that the database belongs to.
	ClusterId string `protobuf:"bytes,2,opt,name=cluster_id,json=clusterId,proto3" json:"cluster_id,omitempty"`
	// Name of the user assigned as the owner of the database.
	Owner string `protobuf:"bytes,3,opt,name=owner,proto3" json:"owner,omitempty"`
	// POSIX locale for string sorting order.
	// Can only be set at creation time.
	LcCollate string `protobuf:"bytes,4,opt,name=lc_collate,json=lcCollate,proto3" json:"lc_collate,omitempty"`
	// POSIX locale for character classification.
	// Can only be set at creation time.
	LcCtype string `protobuf:"bytes,5,opt,name=lc_ctype,json=lcCtype,proto3" json:"lc_ctype,omitempty"`
	// PostgreSQL extensions enabled for the database.
	Extensions           []*Extension `protobuf:"bytes,6,rep,name=extensions,proto3" json:"extensions,omitempty"`
	XXX_NoUnkeyedLiteral struct{}     `json:"-"`
	XXX_unrecognized     []byte       `json:"-"`
	XXX_sizecache        int32        `json:"-"`
}

func (m *Database) Reset()         { *m = Database{} }
func (m *Database) String() string { return proto.CompactTextString(m) }
func (*Database) ProtoMessage()    {}
func (*Database) Descriptor() ([]byte, []int) {
	return fileDescriptor_5f036bfe45d2a329, []int{0}
}

func (m *Database) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Database.Unmarshal(m, b)
}
func (m *Database) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Database.Marshal(b, m, deterministic)
}
func (m *Database) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Database.Merge(m, src)
}
func (m *Database) XXX_Size() int {
	return xxx_messageInfo_Database.Size(m)
}
func (m *Database) XXX_DiscardUnknown() {
	xxx_messageInfo_Database.DiscardUnknown(m)
}

var xxx_messageInfo_Database proto.InternalMessageInfo

func (m *Database) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *Database) GetClusterId() string {
	if m != nil {
		return m.ClusterId
	}
	return ""
}

func (m *Database) GetOwner() string {
	if m != nil {
		return m.Owner
	}
	return ""
}

func (m *Database) GetLcCollate() string {
	if m != nil {
		return m.LcCollate
	}
	return ""
}

func (m *Database) GetLcCtype() string {
	if m != nil {
		return m.LcCtype
	}
	return ""
}

func (m *Database) GetExtensions() []*Extension {
	if m != nil {
		return m.Extensions
	}
	return nil
}

type Extension struct {
	// Name of the extension, e.g. `pg_trgm` or `pg_btree`.
	// Extensions supported by Managed Service for PostgreSQL are [listed in the Developer's Guide](/docs/managed-postgresql/operations/cluster-extensions).
	Name string `protobuf:"bytes,1,opt,name=name,proto3" json:"name,omitempty"`
	// Version of the extension.
	Version              string   `protobuf:"bytes,2,opt,name=version,proto3" json:"version,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *Extension) Reset()         { *m = Extension{} }
func (m *Extension) String() string { return proto.CompactTextString(m) }
func (*Extension) ProtoMessage()    {}
func (*Extension) Descriptor() ([]byte, []int) {
	return fileDescriptor_5f036bfe45d2a329, []int{1}
}

func (m *Extension) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Extension.Unmarshal(m, b)
}
func (m *Extension) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Extension.Marshal(b, m, deterministic)
}
func (m *Extension) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Extension.Merge(m, src)
}
func (m *Extension) XXX_Size() int {
	return xxx_messageInfo_Extension.Size(m)
}
func (m *Extension) XXX_DiscardUnknown() {
	xxx_messageInfo_Extension.DiscardUnknown(m)
}

var xxx_messageInfo_Extension proto.InternalMessageInfo

func (m *Extension) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *Extension) GetVersion() string {
	if m != nil {
		return m.Version
	}
	return ""
}

type DatabaseSpec struct {
	// Name of the PostgreSQL database. 1-63 characters long.
	Name string `protobuf:"bytes,1,opt,name=name,proto3" json:"name,omitempty"`
	// Name of the user to be assigned as the owner of the database.
	// To get the list of available PostgreSQL users, make a [UserService.List] request.
	Owner string `protobuf:"bytes,2,opt,name=owner,proto3" json:"owner,omitempty"`
	// POSIX locale for string sorting order.
	// Can only be set at creation time.
	LcCollate string `protobuf:"bytes,3,opt,name=lc_collate,json=lcCollate,proto3" json:"lc_collate,omitempty"`
	// POSIX locale for character classification.
	// Can only be set at creation time.
	LcCtype string `protobuf:"bytes,4,opt,name=lc_ctype,json=lcCtype,proto3" json:"lc_ctype,omitempty"`
	// PostgreSQL extensions to be enabled for the database.
	Extensions           []*Extension `protobuf:"bytes,5,rep,name=extensions,proto3" json:"extensions,omitempty"`
	XXX_NoUnkeyedLiteral struct{}     `json:"-"`
	XXX_unrecognized     []byte       `json:"-"`
	XXX_sizecache        int32        `json:"-"`
}

func (m *DatabaseSpec) Reset()         { *m = DatabaseSpec{} }
func (m *DatabaseSpec) String() string { return proto.CompactTextString(m) }
func (*DatabaseSpec) ProtoMessage()    {}
func (*DatabaseSpec) Descriptor() ([]byte, []int) {
	return fileDescriptor_5f036bfe45d2a329, []int{2}
}

func (m *DatabaseSpec) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_DatabaseSpec.Unmarshal(m, b)
}
func (m *DatabaseSpec) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_DatabaseSpec.Marshal(b, m, deterministic)
}
func (m *DatabaseSpec) XXX_Merge(src proto.Message) {
	xxx_messageInfo_DatabaseSpec.Merge(m, src)
}
func (m *DatabaseSpec) XXX_Size() int {
	return xxx_messageInfo_DatabaseSpec.Size(m)
}
func (m *DatabaseSpec) XXX_DiscardUnknown() {
	xxx_messageInfo_DatabaseSpec.DiscardUnknown(m)
}

var xxx_messageInfo_DatabaseSpec proto.InternalMessageInfo

func (m *DatabaseSpec) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *DatabaseSpec) GetOwner() string {
	if m != nil {
		return m.Owner
	}
	return ""
}

func (m *DatabaseSpec) GetLcCollate() string {
	if m != nil {
		return m.LcCollate
	}
	return ""
}

func (m *DatabaseSpec) GetLcCtype() string {
	if m != nil {
		return m.LcCtype
	}
	return ""
}

func (m *DatabaseSpec) GetExtensions() []*Extension {
	if m != nil {
		return m.Extensions
	}
	return nil
}

func init() {
	proto.RegisterType((*Database)(nil), "yandex.cloud.mdb.postgresql.v1.Database")
	proto.RegisterType((*Extension)(nil), "yandex.cloud.mdb.postgresql.v1.Extension")
	proto.RegisterType((*DatabaseSpec)(nil), "yandex.cloud.mdb.postgresql.v1.DatabaseSpec")
}

func init() {
	proto.RegisterFile("yandex/cloud/mdb/postgresql/v1/database.proto", fileDescriptor_5f036bfe45d2a329)
}

var fileDescriptor_5f036bfe45d2a329 = []byte{
	// 414 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xa4, 0x92, 0x4f, 0x8e, 0xd3, 0x30,
	0x14, 0x87, 0x95, 0x99, 0x74, 0x66, 0x6a, 0xfe, 0x2c, 0x0c, 0x12, 0x01, 0xa9, 0xa3, 0x51, 0x56,
	0x05, 0x64, 0x87, 0xb4, 0x52, 0x45, 0x05, 0x2c, 0x48, 0x01, 0xa9, 0x0b, 0x36, 0x05, 0x36, 0x45,
	0x55, 0xe4, 0xd8, 0x56, 0x88, 0xe4, 0xc4, 0x21, 0x71, 0x43, 0x8b, 0x7a, 0x02, 0x0e, 0xc3, 0x35,
	0xca, 0x11, 0x38, 0x02, 0xeb, 0x9e, 0x00, 0xc5, 0x49, 0x68, 0x2a, 0xa0, 0x9b, 0xd9, 0xf9, 0xf9,
	0xf7, 0xbe, 0x27, 0xbd, 0x4f, 0x0f, 0xa0, 0x35, 0x49, 0x18, 0x5f, 0x39, 0x54, 0xc8, 0x25, 0x73,
	0x62, 0x16, 0x38, 0xa9, 0xcc, 0x55, 0x98, 0xf1, 0xfc, 0xb3, 0x70, 0x0a, 0xd7, 0x61, 0x44, 0x91,
	0x80, 0xe4, 0x1c, 0xa7, 0x99, 0x54, 0x12, 0x5e, 0x56, 0xed, 0x58, 0xb7, 0xe3, 0x98, 0x05, 0x78,
	0xdf, 0x8e, 0x0b, 0xf7, 0x41, 0xef, 0x60, 0x5c, 0x41, 0x44, 0xc4, 0x88, 0x8a, 0x64, 0x52, 0xe1,
	0xf6, 0x4f, 0x03, 0x5c, 0xbc, 0xaa, 0x27, 0x42, 0x08, 0xcc, 0x84, 0xc4, 0xdc, 0x32, 0xae, 0x8c,
	0x7e, 0x77, 0xa6, 0xdf, 0xb0, 0x07, 0x00, 0x15, 0xcb, 0x5c, 0xf1, 0xcc, 0x8f, 0x98, 0x75, 0xa2,
	0x93, 0x6e, 0xfd, 0x33, 0x65, 0xf0, 0x2e, 0xe8, 0xc8, 0x2f, 0x09, 0xcf, 0xac, 0x53, 0x9d, 0x54,
	0x45, 0x09, 0x09, 0xea, 0x53, 0x29, 0x04, 0x51, 0xdc, 0x32, 0x2b, 0x48, 0xd0, 0x49, 0xf5, 0x01,
	0xef, 0x83, 0x8b, 0x32, 0x56, 0xeb, 0x94, 0x5b, 0x1d, 0x1d, 0x9e, 0x0b, 0x3a, 0x29, 0x4b, 0x38,
	0x05, 0x80, 0xaf, 0x14, 0x4f, 0xf2, 0x48, 0x26, 0xb9, 0x75, 0x76, 0x75, 0xda, 0xbf, 0x31, 0x78,
	0x88, 0x8f, 0xef, 0x88, 0x5f, 0x37, 0xc4, 0xac, 0x05, 0xdb, 0x63, 0xd0, 0xfd, 0x13, 0xfc, 0x73,
	0x35, 0x0b, 0x9c, 0x17, 0x3c, 0x2b, 0xe3, 0x7a, 0xaf, 0xa6, 0xb4, 0xbf, 0x9f, 0x80, 0x9b, 0x8d,
	0x95, 0x77, 0x29, 0xa7, 0x70, 0xd0, 0xc6, 0xbd, 0xcb, 0x5f, 0x5b, 0xd7, 0xd8, 0x6d, 0xdd, 0xdb,
	0x1f, 0x09, 0xfa, 0xfa, 0x12, 0xcd, 0x9f, 0xa0, 0xb1, 0x8f, 0x16, 0x8f, 0xbe, 0xfd, 0x70, 0xcd,
	0xe7, 0x2f, 0x46, 0xc3, 0x7a, 0xfc, 0xb0, 0x51, 0xa3, 0x87, 0x7b, 0xbd, 0x1a, 0xba, 0xd5, 0x82,
	0x5a, 0x4c, 0x6d, 0x6e, 0x74, 0x60, 0x4e, 0x4b, 0xf5, 0xee, 0xed, 0xb6, 0xee, 0x9d, 0x4d, 0x8d,
	0xf9, 0x8b, 0xc7, 0xf8, 0xc3, 0xfb, 0x37, 0xe8, 0xe9, 0x66, 0xd2, 0x56, 0x3a, 0x68, 0x29, 0x35,
	0x8f, 0x53, 0xff, 0x71, 0xdd, 0xb9, 0x86, 0x6b, 0x2f, 0x07, 0xf6, 0x01, 0x47, 0xd2, 0xe8, 0x6f,
	0x76, 0xfe, 0x36, 0x8c, 0xd4, 0xa7, 0x65, 0x80, 0xa9, 0x8c, 0x9d, 0xaa, 0x1d, 0x55, 0x67, 0x19,
	0x4a, 0x14, 0xf2, 0x44, 0x5f, 0xa4, 0x73, 0xfc, 0xfc, 0x9f, 0xed, 0xab, 0xe0, 0x4c, 0x03, 0xc3,
	0xdf, 0x01, 0x00, 0x00, 0xff, 0xff, 0x8e, 0xb7, 0x73, 0x67, 0x32, 0x03, 0x00, 0x00,
}
