// Code generated by protoc-gen-go. DO NOT EDIT.
// source: yandex/cloud/serverless/functions/v1/function.proto

package functions

import (
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	duration "github.com/golang/protobuf/ptypes/duration"
	timestamp "github.com/golang/protobuf/ptypes/timestamp"
	_ "github.com/yandex-cloud/go-genproto/yandex/cloud"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

type Function_Status int32

const (
	Function_STATUS_UNSPECIFIED Function_Status = 0
	// Function is being created.
	Function_CREATING Function_Status = 1
	// Function is ready to be invoked.
	Function_ACTIVE Function_Status = 2
	// Function is being deleted.
	Function_DELETING Function_Status = 3
	// Function failed.
	Function_ERROR Function_Status = 4
)

var Function_Status_name = map[int32]string{
	0: "STATUS_UNSPECIFIED",
	1: "CREATING",
	2: "ACTIVE",
	3: "DELETING",
	4: "ERROR",
}

var Function_Status_value = map[string]int32{
	"STATUS_UNSPECIFIED": 0,
	"CREATING":           1,
	"ACTIVE":             2,
	"DELETING":           3,
	"ERROR":              4,
}

func (x Function_Status) String() string {
	return proto.EnumName(Function_Status_name, int32(x))
}

func (Function_Status) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_f916220b45cd549e, []int{0, 0}
}

type Version_Status int32

const (
	Version_STATUS_UNSPECIFIED Version_Status = 0
	// Version is being created.
	Version_CREATING Version_Status = 1
	// Version is ready to use.
	Version_ACTIVE Version_Status = 2
)

var Version_Status_name = map[int32]string{
	0: "STATUS_UNSPECIFIED",
	1: "CREATING",
	2: "ACTIVE",
}

var Version_Status_value = map[string]int32{
	"STATUS_UNSPECIFIED": 0,
	"CREATING":           1,
	"ACTIVE":             2,
}

func (x Version_Status) String() string {
	return proto.EnumName(Version_Status_name, int32(x))
}

func (Version_Status) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_f916220b45cd549e, []int{1, 0}
}

// A serverless function. For details about the concept, see [Functions](/docs/functions/concepts/function).
type Function struct {
	// ID of the function. Generated at creation time.
	Id string `protobuf:"bytes,1,opt,name=id,proto3" json:"id,omitempty"`
	// ID of the folder that the function belongs to.
	FolderId string `protobuf:"bytes,2,opt,name=folder_id,json=folderId,proto3" json:"folder_id,omitempty"`
	// Creation timestamp for the function.
	CreatedAt *timestamp.Timestamp `protobuf:"bytes,3,opt,name=created_at,json=createdAt,proto3" json:"created_at,omitempty"`
	// Name of the function. The name is unique within the folder.
	Name string `protobuf:"bytes,4,opt,name=name,proto3" json:"name,omitempty"`
	// Description of the function.
	Description string `protobuf:"bytes,5,opt,name=description,proto3" json:"description,omitempty"`
	// Function labels as `key:value` pairs.
	Labels map[string]string `protobuf:"bytes,6,rep,name=labels,proto3" json:"labels,omitempty" protobuf_key:"bytes,1,opt,name=key,proto3" protobuf_val:"bytes,2,opt,name=value,proto3"`
	// ID of the log group for the function.
	LogGroupId string `protobuf:"bytes,7,opt,name=log_group_id,json=logGroupId,proto3" json:"log_group_id,omitempty"`
	// URL that needs to be requested to invoke the function.
	HttpInvokeUrl string `protobuf:"bytes,8,opt,name=http_invoke_url,json=httpInvokeUrl,proto3" json:"http_invoke_url,omitempty"`
	// Status of the function.
	Status               Function_Status `protobuf:"varint,9,opt,name=status,proto3,enum=yandex.cloud.serverless.functions.v1.Function_Status" json:"status,omitempty"`
	XXX_NoUnkeyedLiteral struct{}        `json:"-"`
	XXX_unrecognized     []byte          `json:"-"`
	XXX_sizecache        int32           `json:"-"`
}

func (m *Function) Reset()         { *m = Function{} }
func (m *Function) String() string { return proto.CompactTextString(m) }
func (*Function) ProtoMessage()    {}
func (*Function) Descriptor() ([]byte, []int) {
	return fileDescriptor_f916220b45cd549e, []int{0}
}

func (m *Function) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Function.Unmarshal(m, b)
}
func (m *Function) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Function.Marshal(b, m, deterministic)
}
func (m *Function) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Function.Merge(m, src)
}
func (m *Function) XXX_Size() int {
	return xxx_messageInfo_Function.Size(m)
}
func (m *Function) XXX_DiscardUnknown() {
	xxx_messageInfo_Function.DiscardUnknown(m)
}

var xxx_messageInfo_Function proto.InternalMessageInfo

func (m *Function) GetId() string {
	if m != nil {
		return m.Id
	}
	return ""
}

func (m *Function) GetFolderId() string {
	if m != nil {
		return m.FolderId
	}
	return ""
}

func (m *Function) GetCreatedAt() *timestamp.Timestamp {
	if m != nil {
		return m.CreatedAt
	}
	return nil
}

func (m *Function) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *Function) GetDescription() string {
	if m != nil {
		return m.Description
	}
	return ""
}

func (m *Function) GetLabels() map[string]string {
	if m != nil {
		return m.Labels
	}
	return nil
}

func (m *Function) GetLogGroupId() string {
	if m != nil {
		return m.LogGroupId
	}
	return ""
}

func (m *Function) GetHttpInvokeUrl() string {
	if m != nil {
		return m.HttpInvokeUrl
	}
	return ""
}

func (m *Function) GetStatus() Function_Status {
	if m != nil {
		return m.Status
	}
	return Function_STATUS_UNSPECIFIED
}

// Version of a function. For details about the concept, see [Function versions](/docs/functions/concepts/function#version).
type Version struct {
	// ID of the version.
	Id string `protobuf:"bytes,1,opt,name=id,proto3" json:"id,omitempty"`
	// ID of the function that the version belongs to.
	FunctionId string `protobuf:"bytes,2,opt,name=function_id,json=functionId,proto3" json:"function_id,omitempty"`
	// Description of the version.
	Description string `protobuf:"bytes,3,opt,name=description,proto3" json:"description,omitempty"`
	// Creation timestamp for the version.
	CreatedAt *timestamp.Timestamp `protobuf:"bytes,5,opt,name=created_at,json=createdAt,proto3" json:"created_at,omitempty"`
	// ID of the runtime environment for the function.
	//
	// Supported environments and their identifiers are listed in the [Runtime environments](/docs/functions/concepts/runtime).
	Runtime string `protobuf:"bytes,6,opt,name=runtime,proto3" json:"runtime,omitempty"`
	// Entrypoint for the function: the name of the function to be called as the handler.
	//
	// Specified in the format `<function file name>.<handler name>`, for example, `index.myFunction`.
	Entrypoint string `protobuf:"bytes,7,opt,name=entrypoint,proto3" json:"entrypoint,omitempty"`
	// Resources allocated to the version.
	Resources *Resources `protobuf:"bytes,8,opt,name=resources,proto3" json:"resources,omitempty"`
	// Timeout for the execution of the version.
	//
	// If the timeout is exceeded, Cloud Functions responds with a 504 HTTP code.
	ExecutionTimeout *duration.Duration `protobuf:"bytes,9,opt,name=execution_timeout,json=executionTimeout,proto3" json:"execution_timeout,omitempty"`
	// ID of the service account associated with the version.
	ServiceAccountId string `protobuf:"bytes,10,opt,name=service_account_id,json=serviceAccountId,proto3" json:"service_account_id,omitempty"`
	// Final size of the deployment package after unpacking.
	ImageSize int64 `protobuf:"varint,12,opt,name=image_size,json=imageSize,proto3" json:"image_size,omitempty"`
	// Status of the version.
	Status Version_Status `protobuf:"varint,13,opt,name=status,proto3,enum=yandex.cloud.serverless.functions.v1.Version_Status" json:"status,omitempty"`
	// Version tags. For details, see [Version tag](/docs/functions/concepts/function#tag).
	Tags []string `protobuf:"bytes,14,rep,name=tags,proto3" json:"tags,omitempty"`
	// ID of the log group for the version.
	LogGroupId string `protobuf:"bytes,15,opt,name=log_group_id,json=logGroupId,proto3" json:"log_group_id,omitempty"`
	// Environment settings for the version.
	Environment map[string]string `protobuf:"bytes,16,rep,name=environment,proto3" json:"environment,omitempty" protobuf_key:"bytes,1,opt,name=key,proto3" protobuf_val:"bytes,2,opt,name=value,proto3"`
	// Network access. If specified the version will be attached to specified network/subnet(s).
	Connectivity         *Connectivity `protobuf:"bytes,17,opt,name=connectivity,proto3" json:"connectivity,omitempty"`
	XXX_NoUnkeyedLiteral struct{}      `json:"-"`
	XXX_unrecognized     []byte        `json:"-"`
	XXX_sizecache        int32         `json:"-"`
}

func (m *Version) Reset()         { *m = Version{} }
func (m *Version) String() string { return proto.CompactTextString(m) }
func (*Version) ProtoMessage()    {}
func (*Version) Descriptor() ([]byte, []int) {
	return fileDescriptor_f916220b45cd549e, []int{1}
}

func (m *Version) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Version.Unmarshal(m, b)
}
func (m *Version) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Version.Marshal(b, m, deterministic)
}
func (m *Version) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Version.Merge(m, src)
}
func (m *Version) XXX_Size() int {
	return xxx_messageInfo_Version.Size(m)
}
func (m *Version) XXX_DiscardUnknown() {
	xxx_messageInfo_Version.DiscardUnknown(m)
}

var xxx_messageInfo_Version proto.InternalMessageInfo

func (m *Version) GetId() string {
	if m != nil {
		return m.Id
	}
	return ""
}

func (m *Version) GetFunctionId() string {
	if m != nil {
		return m.FunctionId
	}
	return ""
}

func (m *Version) GetDescription() string {
	if m != nil {
		return m.Description
	}
	return ""
}

func (m *Version) GetCreatedAt() *timestamp.Timestamp {
	if m != nil {
		return m.CreatedAt
	}
	return nil
}

func (m *Version) GetRuntime() string {
	if m != nil {
		return m.Runtime
	}
	return ""
}

func (m *Version) GetEntrypoint() string {
	if m != nil {
		return m.Entrypoint
	}
	return ""
}

func (m *Version) GetResources() *Resources {
	if m != nil {
		return m.Resources
	}
	return nil
}

func (m *Version) GetExecutionTimeout() *duration.Duration {
	if m != nil {
		return m.ExecutionTimeout
	}
	return nil
}

func (m *Version) GetServiceAccountId() string {
	if m != nil {
		return m.ServiceAccountId
	}
	return ""
}

func (m *Version) GetImageSize() int64 {
	if m != nil {
		return m.ImageSize
	}
	return 0
}

func (m *Version) GetStatus() Version_Status {
	if m != nil {
		return m.Status
	}
	return Version_STATUS_UNSPECIFIED
}

func (m *Version) GetTags() []string {
	if m != nil {
		return m.Tags
	}
	return nil
}

func (m *Version) GetLogGroupId() string {
	if m != nil {
		return m.LogGroupId
	}
	return ""
}

func (m *Version) GetEnvironment() map[string]string {
	if m != nil {
		return m.Environment
	}
	return nil
}

func (m *Version) GetConnectivity() *Connectivity {
	if m != nil {
		return m.Connectivity
	}
	return nil
}

// Resources allocated to a version.
type Resources struct {
	// Amount of memory available to the version, specified in bytes.
	Memory               int64    `protobuf:"varint,1,opt,name=memory,proto3" json:"memory,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *Resources) Reset()         { *m = Resources{} }
func (m *Resources) String() string { return proto.CompactTextString(m) }
func (*Resources) ProtoMessage()    {}
func (*Resources) Descriptor() ([]byte, []int) {
	return fileDescriptor_f916220b45cd549e, []int{2}
}

func (m *Resources) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Resources.Unmarshal(m, b)
}
func (m *Resources) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Resources.Marshal(b, m, deterministic)
}
func (m *Resources) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Resources.Merge(m, src)
}
func (m *Resources) XXX_Size() int {
	return xxx_messageInfo_Resources.Size(m)
}
func (m *Resources) XXX_DiscardUnknown() {
	xxx_messageInfo_Resources.DiscardUnknown(m)
}

var xxx_messageInfo_Resources proto.InternalMessageInfo

func (m *Resources) GetMemory() int64 {
	if m != nil {
		return m.Memory
	}
	return 0
}

// Version deployment package.
type Package struct {
	// Name of the bucket that stores the code for the version.
	BucketName string `protobuf:"bytes,1,opt,name=bucket_name,json=bucketName,proto3" json:"bucket_name,omitempty"`
	// Name of the object in the bucket that stores the code for the version.
	ObjectName string `protobuf:"bytes,2,opt,name=object_name,json=objectName,proto3" json:"object_name,omitempty"`
	// SHA256 hash of the version deployment package.
	Sha256               string   `protobuf:"bytes,3,opt,name=sha256,proto3" json:"sha256,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *Package) Reset()         { *m = Package{} }
func (m *Package) String() string { return proto.CompactTextString(m) }
func (*Package) ProtoMessage()    {}
func (*Package) Descriptor() ([]byte, []int) {
	return fileDescriptor_f916220b45cd549e, []int{3}
}

func (m *Package) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Package.Unmarshal(m, b)
}
func (m *Package) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Package.Marshal(b, m, deterministic)
}
func (m *Package) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Package.Merge(m, src)
}
func (m *Package) XXX_Size() int {
	return xxx_messageInfo_Package.Size(m)
}
func (m *Package) XXX_DiscardUnknown() {
	xxx_messageInfo_Package.DiscardUnknown(m)
}

var xxx_messageInfo_Package proto.InternalMessageInfo

func (m *Package) GetBucketName() string {
	if m != nil {
		return m.BucketName
	}
	return ""
}

func (m *Package) GetObjectName() string {
	if m != nil {
		return m.ObjectName
	}
	return ""
}

func (m *Package) GetSha256() string {
	if m != nil {
		return m.Sha256
	}
	return ""
}

// Version connectivity specification.
type Connectivity struct {
	// Network the version will have access to.
	// It's essential to specify network with subnets in all availability zones.
	NetworkId string `protobuf:"bytes,1,opt,name=network_id,json=networkId,proto3" json:"network_id,omitempty"`
	// Complete list of subnets (from the same network) the version can be attached to.
	// It's essential to specify at least one subnet for each availability zones.
	SubnetId             []string `protobuf:"bytes,2,rep,name=subnet_id,json=subnetId,proto3" json:"subnet_id,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *Connectivity) Reset()         { *m = Connectivity{} }
func (m *Connectivity) String() string { return proto.CompactTextString(m) }
func (*Connectivity) ProtoMessage()    {}
func (*Connectivity) Descriptor() ([]byte, []int) {
	return fileDescriptor_f916220b45cd549e, []int{4}
}

func (m *Connectivity) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Connectivity.Unmarshal(m, b)
}
func (m *Connectivity) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Connectivity.Marshal(b, m, deterministic)
}
func (m *Connectivity) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Connectivity.Merge(m, src)
}
func (m *Connectivity) XXX_Size() int {
	return xxx_messageInfo_Connectivity.Size(m)
}
func (m *Connectivity) XXX_DiscardUnknown() {
	xxx_messageInfo_Connectivity.DiscardUnknown(m)
}

var xxx_messageInfo_Connectivity proto.InternalMessageInfo

func (m *Connectivity) GetNetworkId() string {
	if m != nil {
		return m.NetworkId
	}
	return ""
}

func (m *Connectivity) GetSubnetId() []string {
	if m != nil {
		return m.SubnetId
	}
	return nil
}

func init() {
	proto.RegisterEnum("yandex.cloud.serverless.functions.v1.Function_Status", Function_Status_name, Function_Status_value)
	proto.RegisterEnum("yandex.cloud.serverless.functions.v1.Version_Status", Version_Status_name, Version_Status_value)
	proto.RegisterType((*Function)(nil), "yandex.cloud.serverless.functions.v1.Function")
	proto.RegisterMapType((map[string]string)(nil), "yandex.cloud.serverless.functions.v1.Function.LabelsEntry")
	proto.RegisterType((*Version)(nil), "yandex.cloud.serverless.functions.v1.Version")
	proto.RegisterMapType((map[string]string)(nil), "yandex.cloud.serverless.functions.v1.Version.EnvironmentEntry")
	proto.RegisterType((*Resources)(nil), "yandex.cloud.serverless.functions.v1.Resources")
	proto.RegisterType((*Package)(nil), "yandex.cloud.serverless.functions.v1.Package")
	proto.RegisterType((*Connectivity)(nil), "yandex.cloud.serverless.functions.v1.Connectivity")
}

func init() {
	proto.RegisterFile("yandex/cloud/serverless/functions/v1/function.proto", fileDescriptor_f916220b45cd549e)
}

var fileDescriptor_f916220b45cd549e = []byte{
	// 937 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x9c, 0x55, 0xcd, 0x6e, 0xdb, 0x46,
	0x10, 0xae, 0xfe, 0x68, 0x71, 0xa8, 0x38, 0xca, 0x22, 0x08, 0x58, 0xb5, 0x49, 0x04, 0xa1, 0x29,
	0x04, 0xb4, 0xa2, 0x4c, 0x4a, 0xfe, 0x89, 0xdb, 0x04, 0x90, 0x6c, 0x3a, 0x60, 0xe1, 0xb8, 0xc1,
	0x4a, 0xf6, 0xa1, 0x28, 0xc0, 0x52, 0xe4, 0x9a, 0x66, 0x45, 0x71, 0x05, 0x72, 0xa9, 0xc6, 0x39,
	0xf4, 0xd0, 0x63, 0x9e, 0xab, 0x40, 0xfc, 0x28, 0x7d, 0x06, 0x9f, 0x0a, 0x2e, 0xa9, 0x1f, 0xdb,
	0x6d, 0x21, 0xf7, 0xc6, 0x9d, 0x99, 0x6f, 0xe6, 0xdb, 0x99, 0x6f, 0x96, 0xd0, 0xb9, 0xb4, 0x02,
	0x87, 0xbc, 0x6f, 0xdb, 0x3e, 0x8d, 0x9d, 0x76, 0x44, 0xc2, 0x19, 0x09, 0x7d, 0x12, 0x45, 0xed,
	0xf3, 0x38, 0xb0, 0x99, 0x47, 0x83, 0xa8, 0x3d, 0x53, 0x17, 0x07, 0x65, 0x1a, 0x52, 0x46, 0xd1,
	0x57, 0x29, 0x48, 0xe1, 0x20, 0x65, 0x09, 0x52, 0x16, 0x20, 0x65, 0xa6, 0xd6, 0x9e, 0xb9, 0x94,
	0xba, 0x3e, 0x69, 0x73, 0xcc, 0x28, 0x3e, 0x6f, 0x3b, 0x71, 0x68, 0x2d, 0xb3, 0xd4, 0x9e, 0xdf,
	0xf6, 0x33, 0x6f, 0x42, 0x22, 0x66, 0x4d, 0xa6, 0x59, 0xc0, 0xd3, 0x1b, 0xdc, 0x66, 0x96, 0xef,
	0x39, 0x2b, 0xf8, 0xc6, 0x9f, 0x45, 0x28, 0x1f, 0x65, 0x05, 0xd1, 0x26, 0xe4, 0x3d, 0x47, 0xce,
	0xd5, 0x73, 0x4d, 0x11, 0xe7, 0x3d, 0x07, 0x7d, 0x01, 0xe2, 0x39, 0xf5, 0x1d, 0x12, 0x9a, 0x9e,
	0x23, 0xe7, 0xb9, 0xb9, 0x9c, 0x1a, 0x0c, 0x07, 0xbd, 0x04, 0xb0, 0x43, 0x62, 0x31, 0xe2, 0x98,
	0x16, 0x93, 0x0b, 0xf5, 0x5c, 0x53, 0xd2, 0x6a, 0x4a, 0x4a, 0x47, 0x99, 0xd3, 0x51, 0x86, 0x73,
	0x3a, 0x58, 0xcc, 0xa2, 0x7b, 0x0c, 0x7d, 0x09, 0xc5, 0xc0, 0x9a, 0x10, 0xb9, 0x98, 0xa4, 0xec,
	0x97, 0x3f, 0x5e, 0xa9, 0xc5, 0x4e, 0x6b, 0xa7, 0x83, 0xb9, 0x15, 0x7d, 0x03, 0x92, 0x43, 0x22,
	0x3b, 0xf4, 0xa6, 0x09, 0x29, 0xb9, 0xc4, 0x83, 0xc4, 0x8f, 0x57, 0x6a, 0x69, 0xab, 0xa5, 0x6d,
	0xef, 0xe0, 0x55, 0x2f, 0xfa, 0x19, 0x04, 0xdf, 0x1a, 0x11, 0x3f, 0x92, 0x85, 0x7a, 0xa1, 0x29,
	0x69, 0xfb, 0xca, 0x3a, 0x6d, 0x55, 0xe6, 0x57, 0x56, 0x8e, 0x39, 0x58, 0x0f, 0x58, 0x78, 0xd9,
	0x2f, 0xff, 0x71, 0xa5, 0x16, 0xbf, 0x7f, 0xb5, 0xd3, 0xc5, 0x59, 0x4e, 0x54, 0x87, 0x8a, 0x4f,
	0x5d, 0xd3, 0x0d, 0x69, 0x3c, 0x4d, 0x7a, 0xb0, 0xc1, 0x7b, 0x00, 0x3e, 0x75, 0xdf, 0x24, 0x26,
	0xc3, 0x41, 0x5f, 0xc3, 0xc3, 0x0b, 0xc6, 0xa6, 0xa6, 0x17, 0xcc, 0xe8, 0x98, 0x98, 0x71, 0xe8,
	0xcb, 0x65, 0x1e, 0xf4, 0x20, 0x31, 0x1b, 0xdc, 0x7a, 0x1a, 0xfa, 0xe8, 0x2d, 0x08, 0x11, 0xb3,
	0x58, 0x1c, 0xc9, 0x62, 0x3d, 0xd7, 0xdc, 0xd4, 0xb6, 0xef, 0xc9, 0x73, 0xc0, 0xc1, 0x38, 0x4b,
	0x52, 0x7b, 0x09, 0xd2, 0x0a, 0x73, 0x54, 0x85, 0xc2, 0x98, 0x5c, 0x66, 0x93, 0x4b, 0x3e, 0xd1,
	0x63, 0x28, 0xcd, 0x2c, 0x3f, 0x26, 0xd9, 0xd8, 0xd2, 0xc3, 0x7e, 0x7e, 0x2f, 0xd7, 0x18, 0x80,
	0x90, 0x26, 0x43, 0x4f, 0x00, 0x0d, 0x86, 0xbd, 0xe1, 0xe9, 0xc0, 0x3c, 0x3d, 0x19, 0xbc, 0xd3,
	0x0f, 0x8c, 0x23, 0x43, 0x3f, 0xac, 0x7e, 0x86, 0x2a, 0x50, 0x3e, 0xc0, 0x7a, 0x6f, 0x68, 0x9c,
	0xbc, 0xa9, 0xe6, 0x10, 0x80, 0xd0, 0x3b, 0x18, 0x1a, 0x67, 0x7a, 0x35, 0x9f, 0x78, 0x0e, 0xf5,
	0x63, 0x9d, 0x7b, 0x0a, 0x48, 0x84, 0x92, 0x8e, 0xf1, 0x8f, 0xb8, 0x5a, 0x6c, 0x5c, 0x0b, 0xb0,
	0x71, 0x46, 0xc2, 0xe8, 0x9f, 0x54, 0xf4, 0x1c, 0xa4, 0xf9, 0x9d, 0x96, 0x3a, 0x82, 0xb9, 0xc9,
	0x70, 0x6e, 0x0f, 0xbc, 0xf0, 0x9f, 0x03, 0xbf, 0x29, 0xbb, 0xd2, 0x7d, 0x64, 0x27, 0xc3, 0x46,
	0x18, 0x07, 0xc9, 0x82, 0xc8, 0x02, 0x27, 0x31, 0x3f, 0xa2, 0x67, 0x00, 0x24, 0x69, 0xe4, 0x94,
	0x7a, 0x01, 0x9b, 0x4f, 0x79, 0x69, 0x41, 0x6f, 0x41, 0x0c, 0x49, 0x44, 0xe3, 0xd0, 0x26, 0x11,
	0x9f, 0xaf, 0xa4, 0xb5, 0xd7, 0x1b, 0x20, 0x9e, 0xc3, 0xf0, 0x32, 0x03, 0x3a, 0x82, 0x47, 0xe4,
	0x3d, 0xb1, 0x63, 0xde, 0x92, 0x84, 0x00, 0x8d, 0x19, 0xd7, 0x85, 0xa4, 0x7d, 0x7e, 0xe7, 0x2a,
	0x87, 0xd9, 0xc2, 0xe3, 0xea, 0x02, 0x33, 0x4c, 0x21, 0xe8, 0x5b, 0x40, 0x49, 0x5d, 0xcf, 0x26,
	0xa6, 0x65, 0xdb, 0x34, 0x0e, 0x58, 0xd2, 0x60, 0xe0, 0xf4, 0xab, 0x99, 0xa7, 0x97, 0x3a, 0x0c,
	0x07, 0x3d, 0x05, 0xf0, 0x26, 0x96, 0x4b, 0xcc, 0xc8, 0xfb, 0x40, 0xe4, 0x4a, 0x3d, 0xd7, 0x2c,
	0x60, 0x91, 0x5b, 0x06, 0xde, 0x07, 0x82, 0x8e, 0x17, 0x0a, 0x7d, 0xc0, 0x15, 0xda, 0x5d, 0xef,
	0x82, 0xd9, 0xd4, 0x6f, 0x09, 0x14, 0x21, 0x28, 0x32, 0xcb, 0x8d, 0xe4, 0xcd, 0x7a, 0xa1, 0x29,
	0x62, 0xfe, 0x7d, 0x67, 0x9b, 0x1e, 0xde, 0xd9, 0xa6, 0x5f, 0x40, 0x22, 0xc1, 0xcc, 0x0b, 0x69,
	0x30, 0x21, 0x01, 0x93, 0xab, 0x7c, 0xa5, 0x5f, 0xdf, 0x8f, 0x88, 0xbe, 0x4c, 0xc0, 0x97, 0x03,
	0xaf, 0xa6, 0x44, 0x67, 0x50, 0xb1, 0x69, 0x10, 0x10, 0x9b, 0x79, 0x33, 0x8f, 0x5d, 0xca, 0x8f,
	0x78, 0xd7, 0xb5, 0xf5, 0x4a, 0x1c, 0xac, 0x20, 0xf1, 0x8d, 0x3c, 0xb5, 0xd7, 0x50, 0xbd, 0x5d,
	0xf8, 0x5e, 0x5b, 0xb9, 0xff, 0xff, 0xb7, 0xb2, 0xf1, 0x0a, 0xc4, 0x85, 0xcc, 0xd0, 0x16, 0x08,
	0x13, 0x32, 0xa1, 0x61, 0x5a, 0xb7, 0xd0, 0x97, 0xaf, 0x3f, 0xa9, 0x8f, 0xd5, 0x4e, 0x57, 0x53,
	0x77, 0x77, 0xb5, 0xbd, 0x96, 0xba, 0xb5, 0xdb, 0xd9, 0xed, 0xaa, 0x7b, 0x5a, 0x17, 0x67, 0x71,
	0x0d, 0x0a, 0x1b, 0xef, 0x2c, 0x7b, 0x6c, 0xb9, 0x04, 0xbd, 0x00, 0x69, 0x14, 0xdb, 0x63, 0xc2,
	0x4c, 0xfe, 0x3e, 0x73, 0xe6, 0xfd, 0xe2, 0x5f, 0x9f, 0xd4, 0x1c, 0x86, 0xd4, 0x71, 0x92, 0xbc,
	0xd0, 0x2f, 0x40, 0xa2, 0xa3, 0x5f, 0x89, 0x9d, 0x85, 0xe5, 0x57, 0xc3, 0x52, 0x07, 0x0f, 0x7b,
	0x02, 0x42, 0x74, 0x61, 0x69, 0xdb, 0x3b, 0xe9, 0x4a, 0xe3, 0xec, 0xd4, 0xf8, 0x01, 0x2a, 0xab,
	0x9d, 0x4c, 0x84, 0x19, 0x10, 0xf6, 0x1b, 0x0d, 0xc7, 0xe6, 0xe2, 0xe1, 0x10, 0x33, 0x8b, 0xc1,
	0xff, 0x42, 0x51, 0x3c, 0x0a, 0x08, 0x4b, 0x5f, 0x8f, 0x44, 0x4f, 0xe5, 0xd4, 0x60, 0x38, 0xfd,
	0xdf, 0xa1, 0x79, 0x63, 0x74, 0xd6, 0xd4, 0xfb, 0xb7, 0xf1, 0xfd, 0x84, 0x5d, 0x8f, 0x5d, 0xc4,
	0x23, 0xc5, 0xa6, 0x93, 0x76, 0x0a, 0x6a, 0xa5, 0x7f, 0x45, 0x97, 0xb6, 0x5c, 0x12, 0xf0, 0x8d,
	0x6b, 0xaf, 0xf3, 0x2b, 0xff, 0x6e, 0x71, 0x18, 0x09, 0x1c, 0xd5, 0xf9, 0x3b, 0x00, 0x00, 0xff,
	0xff, 0x2c, 0x40, 0xcc, 0x25, 0x03, 0x08, 0x00, 0x00,
}
